#include "stdafx.h"
#include "Sample_VI.h"
#include "Sample_VIDlg.h"
#include "afxdialogex.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CSample_VIDlg::CSample_VIDlg(CWnd* pParent)
	: CDialogEx(CSample_VIDlg::IDD, pParent)
	, m_bState(false)	//   
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSample_VIDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	//     
	DDX_Control(pDX, IDC_SRVCTRL1, m_server);
}

BEGIN_MESSAGE_MAP(CSample_VIDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON1, &CSample_VIDlg::OnBnClickedButton1)
END_MESSAGE_MAP()

BEGIN_EVENTSINK_MAP(CSample_VIDlg, CDialogEx)
	ON_EVENT(CSample_VIDlg, IDC_SRVCTRL1, 1, CSample_VIDlg::ModifySrvctrl1, VTS_I4)
END_EVENTSINK_MAP()

BOOL CSample_VIDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			
	SetIcon(m_hIcon, FALSE);

	//        
	m_nError = m_server.ConnectDac(-1);
	//    
	if (m_nError != 0)
	{
		// 
		PostMessage(WM_CLOSE);
		return FALSE;
	}
	//     
	m_nMaxQuanChanDac = m_server.MaxQuanChanDac();
	//    
	m_nChanNumberDac = -1;
	//     
	for(long i = 0; i < m_nMaxQuanChanDac; i++)
	{
		//   
		if(m_server.IsFreeChanDac(i) == 0) 
		{
			//    
			m_nChanNumberDac = i;
			//  
			break;
		}
	}

	//       
	if(m_nChanNumberDac == -1)
	{
		// 
		PostMessage(WM_CLOSE);
		return FALSE;
	}

	//   
	m_server.SetChanDac(m_nChanNumberDac);
	//    
	m_server.SetAttenuation(m_nChanNumberDac, 1.f);
	// -  
	long chanId;
	//    
	m_nChanNumberVirt = m_server.IdChanDac(m_nChanNumberDac, &chanId);
	//      
	m_fCurrentTime = m_server.CurrentTime(m_nChanNumberVirt);
	//          (0.1 )
	m_fTimeDelay = 0.1f;
	//     (0)
	m_fPhasa = 0.f;
	//
	m_fPI = atan(1.) * 4.;
	//      ( 0.5  )
	m_fOper = 0.5f;

	//    ( )
	GetDlgItem(IDC_EDIT1)->SetWindowText(L"1");
	//    ( )
	GetDlgItem(IDC_EDIT2)->SetWindowText(L"10");

	return TRUE;
}

void CSample_VIDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	CDialogEx::OnSysCommand(nID, lParam);
}

void CSample_VIDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

HCURSOR CSample_VIDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CSample_VIDlg::OnClose()
{
	//   
	KillTimer(1);
	//       
	m_server.DisconnectDac(m_nChanNumberDac);
	
	CDialogEx::OnClose();
}

void CSample_VIDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == 1)
	{
		//         
		if(m_fCurrentTime < m_server.CurrentTime(m_nChanNumberVirt))
		{
			//           
			long size = (long)(m_server.FrequencyDac(m_nChanNumberDac) * m_fTimeDelay + 0.5f);
			//    
			if(size > 100000) 
				size = 100000;
			
			//  
			GenerateSignal(generate, size);
			//      
			m_nError = m_server.PutData(m_nChanNumberDac, m_fCurrentTime + m_fOper, size, generate);
			//      
			if(m_fOper > m_server.BufferSize() / m_server.FrequencyDac(m_nChanNumberDac) / 2)
				m_fOper = m_server.BufferSize() / m_server.FrequencyDac(m_nChanNumberDac) / 2;
			//    
			m_fCurrentTime += m_fTimeDelay;
		}
	}

	CDialogEx::OnTimer(nIDEvent);
}

void CSample_VIDlg::GenerateSignal(float* array, long size)
{
	//    
	float freq = 10.f;
	//    
	float amp = 1.f;
	CString text;
	//    
	GetDlgItem(IDC_EDIT1)->GetWindowText(text);
	swscanf(text, L"%f", &amp);
	//    
	GetDlgItem(IDC_EDIT2)->GetWindowText(text);
	swscanf(text, L"%f", &freq);

	//  ( )   ( )
	amp = amp * sqrt(2.) * 1000.;
	//    ,    
	freq = freq / m_server.FrequencyDac(m_nChanNumberDac) * 2. * m_fPI;
	// 
	for(long i = 0; i < size; i++)
	{
		array[i] = (float)(amp * sin(m_fPhasa));
		m_fPhasa += freq;
	}
	//   
	while(m_fPhasa > 2 * m_fPI)
		m_fPhasa -= 2 * m_fPI;
}

void CSample_VIDlg::OnBnClickedButton1()
{
	//   
	m_bState = !m_bState;

	//  
	if (m_bState)
	{
		//      
		m_fPhasa = 0.f;
		//     
		m_fCurrentTime = m_server.CurrentTime(m_nChanNumberVirt);
		//   
		SetTimer(1, 20, NULL);
		//   /
		GetDlgItem(IDC_BUTTON1)->SetWindowText(L"");
	}
	//  
	else
	{
		//   
		KillTimer(1);
		//   /
		GetDlgItem(IDC_BUTTON1)->SetWindowText(L"");
	}
}

void CSample_VIDlg::ModifySrvctrl1(long GlobalPar)
{
	//     
	m_fCurrentTime = m_server.CurrentTime(m_nChanNumberVirt);
}
