// ,               
//          
//   "" 1992-2011.   

#include "stdafx.h"
#include <windows.h> 
#include <conio.h>
#include <stdio.h>
#include <math.h>

#include "zadc_int.h"						//   Zadc.dll

#define MAX_TYPE_DSP	20					//     
#define MAX_DEVICE_NAME	16					//      

int main(int argc, char* argv[])
{
	long typeDevice;						//  
	long numberDSP = 0;						//    
	long Err;								//  
	long enable;							//   /  
	long numChannelsDAC;					//    
	long numWordsDAC;						//   (  )    
	short *pBuffer16DAC = NULL;				//            16 
	long *pBuffer32DAC = NULL;				//           16  
	long sizeBufferDAC;						//     
	long sizeInterruptBufferDAC;			//     
	long sizePacketDAC;						//  ,    
	long sleepTime = 50;					//     ()
	long responseTime = 250;				//     ().     
	long serial;							//   
	char deviceName[MAX_DEVICE_NAME];		//  

	long size;								//  
	long pointerDriverDAC = 0;				//        
	long pointerDriverDAC_old = 0;			//       
	long pointerCycleDAC = 0;				//         

	double freqDAC;							//   
	double attenDAC0 = 0.1;					//       
	double resolutionDAC;					//    

	double currentSinusTime = 0.;				//   
	double deltaSinusTime;					//     
	double volt0;							//   ,    ()
	double amplitudeSin = 0.1;				//    ()
	double freqSin = 10;					//    ()
	
	//      
	for(typeDevice = 0; typeDevice < MAX_TYPE_DSP; typeDevice++)
	{
		//    
		Err = ZOpen(typeDevice, numberDSP);
		//     
		if(Err == 0)
		{
			//    
			Err = ZGetEnableDAC(typeDevice, numberDSP, &enable);
			//    
			if(Err == 0 && enable != 0)
			{
				//    
				break;
			}
			//     
			else
			{
				//    
				printf("ZGetEnableDAC() return Error = 0x%X\n\r", Err);
				//    
				Err = ZClose(typeDevice, numberDSP);
			}
		}
	}

	//       
	if(typeDevice >= MAX_TYPE_DSP)
	{
		//    
		printf("Device not found! Error = 0x%X\n\r", Err);
		getch();
		return 0;
	}
	//      
	else
	{
		//    ,      
		printf("Device found...\n\r");
	}

	//   
	Err = ZGetNameDevice(typeDevice, numberDSP, deviceName, MAX_DEVICE_NAME);
	//     
	if(Err != 0)
	{
		//    
		printf("ZGetNameDevice() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	//     
	else
	{
		//   
		printf("Device name: %s\n\r", deviceName);
	}

	//    
	Err = ZGetSerialNumberDSP(typeDevice, numberDSP, &serial);
	//     
	if(Err != 0)
	{
		//    
		printf("ZGetNameDevice() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	//     
	else
	{
		//    
		printf("Serial number: %ld\n\r", serial);
	}

	//       
	Err = ZSetOutputDAC(typeDevice, numberDSP, 0, 1);
	//     
	if(Err != 0)
	{
		//    
		printf("ZSetOutputDAC() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	//     
	else
	{
		//         
		printf("First channel activation is successful...\n\r");
	}

	//     
	//     ,      
	// (     ,         )
	Err = ZGetNumberOutputDAC(typeDevice, numberDSP, &numChannelsDAC);
	//     
	if(Err != 0)
	{
		//    
		printf("Function ZGetNumberOutputDAC() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	//     
	else
	{
		//      
		printf("Quantity of activated DAC channel: %ld\n\r", numChannelsDAC);
	}

	//        
	Err = ZGetDigitalResolChanDAC(typeDevice, numberDSP, 0, &resolutionDAC);
	//     
	if(Err != 0)
	{
		//    
		printf("ZGetDigitalResolutionDAC() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	//     
	else
	{
		//        
		printf("First channel digital resolution: %f\n\r", resolutionDAC);
	}

	//       
	Err = ZGetWordsDAC(typeDevice, numberDSP, &numWordsDAC);
	//     
	if(Err != 0)
	{
		//    
		printf("ZGetWordsDAC() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	//     
	else
	{
		//        
		printf("Quantity of words: %ld\n\r", numWordsDAC);
	}

	//  s  
	Err = ZGetFreqDAC(typeDevice, numberDSP, &freqDAC);
	//     
 	if(Err != 0)
	{
		//    
		printf("ZGetFreqDAC() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	//     
	else
	{
		//     
		printf("Frequency: %f\n\r", freqDAC);
	}

	//     
	Err = ZGetInterruptDAC(typeDevice, numberDSP, &sizeInterruptBufferDAC);
	//     
	if(Err != 0)
	{
		//    
		printf("ZGetInterruptDAC() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	//     
	else
	{
		//     
		printf("Interrupt buffer size: %ld\n\r", sizeInterruptBufferDAC);
	}

	//          
	Err = ZSetAttenDAC(typeDevice, numberDSP, 0, attenDAC0, &attenDAC0);
	//     
	if(Err != 0)
	{
		//    
		printf("ZSetAttenDAC() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}

	//  ,     
	if(numWordsDAC < 1 || numWordsDAC > 2 || freqDAC < 1. || attenDAC0 == 0. || resolutionDAC == 0.)
	{
		//    
		printf("Error DAC parameters\n\r");
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}

	//   
	Err = ZGetBufferDAC(typeDevice, numberDSP, (void**) &pBuffer16DAC, &sizeBufferDAC);
	//     
	if(Err != 0)
	{
		//    
		printf("Function ZGetBufferDAC() return Error = 0x%X\n\r", Err);
		//    
		Err = ZClose(typeDevice, numberDSP);
		getch();
		return 0;
	}
	pBuffer32DAC = (long*) pBuffer16DAC;

	//        ()
	sizePacketDAC = (long) freqDAC * responseTime / 1000;
	sizePacketDAC = numWordsDAC * sizePacketDAC;

	//                
	if(sizePacketDAC < 2 * sizeInterruptBufferDAC)
		sizePacketDAC = 2 * sizeInterruptBufferDAC;
	if(sizePacketDAC > sizeBufferDAC / 2)
		sizePacketDAC = sizeBufferDAC / 2;

	//       ( "" = 4. * atan(1.))
	amplitudeSin = amplitudeSin / (resolutionDAC * attenDAC0);
	deltaSinusTime = 2. * (4. * atan(1.)) * freqSin / freqDAC;
	
	//       
	size = 2 * sizePacketDAC / numWordsDAC;
	//       16 
	if(numWordsDAC == 1)
	{
		for(long i = 0; i < size; i++)
		{
			volt0 = amplitudeSin * sin(currentSinusTime);
			pBuffer16DAC[i] = (short) volt0;
			currentSinusTime += deltaSinusTime;
		}
	}
	//      16 
	else
	{
		for(long i = 0; i < size; i++)
		{
			volt0 = amplitudeSin * sin(currentSinusTime);
			pBuffer32DAC[i] = (long) volt0;
			currentSinusTime += deltaSinusTime;
		}
	}
	pointerCycleDAC = 2 * sizePacketDAC;

	//    
	Err = ZStopDAC(typeDevice, numberDSP);
	
	//    
	Err = ZStopADC(typeDevice, numberDSP);
	
	//    
	Err = ZStartDAC(typeDevice, numberDSP);
	
	//    
	Err = ZStartADC(typeDevice, numberDSP);
	
	//        
	while(!kbhit())
	{
		//      
		Sleep(sleepTime);

		//      
		Err = ZGetPointerDAC(typeDevice, numberDSP, &pointerDriverDAC);
		//     
		if(Err != 0)
		{
			//    
			printf("Function ZGetPointerDAC() return Error = 0x%X\n\r", Err);
			//   
			break;
		}

		//    
		printf("pointerCycleDAC = %ld, pointerDriverDAC = %ld\n", pointerCycleDAC, pointerDriverDAC);

		//         ,       
		if(pointerCycleDAC - pointerDriverDAC > sizePacketDAC)
			continue;
		if((pointerDriverDAC > pointerCycleDAC) && (sizeBufferDAC - pointerDriverDAC + pointerCycleDAC > sizePacketDAC))
			continue;

		//     
		pointerDriverDAC_old = pointerDriverDAC;

		//       
		size = sizePacketDAC;
        //       ,       
		if(pointerCycleDAC + sizePacketDAC > sizeBufferDAC)
			size = sizeBufferDAC - pointerCycleDAC;
		size = size / numWordsDAC;

		//       16 
		if(numWordsDAC == 1)
		{
			for(long i = 0; i < size; i++)
			{
				volt0 = amplitudeSin * sin(currentSinusTime);
				pBuffer16DAC[pointerCycleDAC + i] = (short) volt0;
				currentSinusTime += deltaSinusTime;
			}
		}
		//      16 
		else
		{
			for(long i = 0; i < size; i++)
			{
				volt0 = amplitudeSin * sin(currentSinusTime);
				pBuffer32DAC[pointerCycleDAC / numWordsDAC + i] = (long) volt0;
				currentSinusTime += deltaSinusTime;
			}
		}
			
		//       
		pointerCycleDAC += numWordsDAC * size;
		//     ,    
		if(pointerCycleDAC >= sizeBufferDAC)
			pointerCycleDAC = 0;

		if(size < (sizePacketDAC / numWordsDAC))
		{
			//        ,     
			size = (sizePacketDAC / numWordsDAC) - size;
			//       16 
			if(numWordsDAC == 1)
			{
				for(long i = 0; i < size; i++)
				{
					volt0 = amplitudeSin * sin(currentSinusTime);
					pBuffer16DAC[pointerCycleDAC + i] = (short) volt0;
					currentSinusTime += deltaSinusTime;
				}
			}
			//      16 
			else
			{
				for(long i = 0; i < size; i++)
				{
					volt0 = amplitudeSin * sin(currentSinusTime);
					pBuffer32DAC[pointerCycleDAC / numWordsDAC + i] = (long) volt0;
					currentSinusTime += deltaSinusTime;
				}
			}

			//       
			pointerCycleDAC += numWordsDAC * size;
		}
	}

	//    
	Err = ZStopDAC(typeDevice, numberDSP);
	
	//    
	Err = ZStopADC(typeDevice, numberDSP);
	
	//     
	if(pBuffer16DAC != NULL)
	{
		Err = ZRemBufferDAC(typeDevice, numberDSP, (void**) &pBuffer16DAC);
		//     
		if(Err != 0)
		{
			//    
			printf("Function ZRemBufferDAC() return Error = 0x%X\n\r", Err);
		}
	}

	//    
	Err = ZClose(typeDevice, numberDSP);
	//     
	if(Err != 0)
	{
		//    
		printf("Function ZClose() return Error = 0x%X\n\r", Err);
	}

	if(!kbhit())
		getch();

	printf("Press any key for exit...");
	getch();

 	return 0;
}
